## hyphy 2.5.60+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.12)
 project(HyPhy)
-cmake_policy(VERSION 3.0.0)
+#cmake_policy(VERSION 3.0.0)
 
 enable_testing()
 #enable_language(Fortran)
@@ -316,6 +316,11 @@
 MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")
 MESSAGE ("Set linker flags to ${DEFAULT_LINK_FLAGS}")
 
+set(BLA_VENDOR Apple)
+find_package(BLAS)
+
+
+
 #-------------------------------------------------------------------------------
 # OpenMP support
 #-------------------------------------------------------------------------------
@@ -349,7 +354,3 @@
 if(${CURL_FOUND})
     message(${CURL_LIBRARIES})
     list(APPEND DEFAULT_LIBRARIES ${CURL_LIBRARIES})
-    add_definitions (-D__HYPHYCURL__)
-endif(${CURL_FOUND})
-
-if(NOT NOZLIB)
