=== debian/changelog ===
hyphy (2.5.60+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.60+dfsg
  * Unfuzz all patches.
  * d/control: migrate build-dep to pkgconf.

 -- Étienne Mollier <emollier@debian.org>  Sun, 10 Mar 2024 12:37:20 +0100
