## hyphy 2.5.62+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 option(NOSSE4 OFF)
 option(NONEON OFF)
 option(NOZLIB OFF)
+option(NOBLAS OFF)
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
    set(NOAVX ON)
