=== debian/changelog ===
hyphy (2.5.62+dfsg-1build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 30 Jul 2024 13:56:30 -0700

hyphy (2.5.62+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.62+dfsg
  * d/control: declare compliance to standards version 4.7.0.
  * Unfuzz all patches.
  * d/copyright: delete reference to */.DS_Store: not distributed anymore.

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Jun 2024 10:41:46 +0200
