## hyphy 2.5.63+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -236,7 +236,7 @@
 		PCL_CHECK_FOR_NEON()
 		if(${HAVE_NEON_EXTENSIONS})
 			add_definitions (-D_SLKP_USE_ARM_NEON)
-
+			set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mcpu=native -mtune=native ")
 		endif(${HAVE_NEON_EXTENSIONS})
 	endif(NOT NONEON)
 
@@ -284,6 +284,8 @@
 		PCL_CHECK_FOR_NEON()
 		if(${HAVE_NEON_EXTENSIONS})
 			add_definitions (-D_SLKP_USE_ARM_NEON)
+			set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mcpu=native -mtune=native ")
+
 		endif(${HAVE_NEON_EXTENSIONS})
 	endif(NOT NONEON)
 
@@ -350,8 +352,3 @@
 
 #-------------------------------------------------------------------------------
 # LIBCurl support
-#-------------------------------------------------------------------------------
-find_package(CURL)
-if(${CURL_FOUND})
-    message(${CURL_LIBRARIES})
-    list(APPEND DEFAULT_LIBRARIES ${CURL_LIBRARIES})
