=== debian/changelog ===
hyphy (2.5.63+dfsg-1build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:13:21 +0100

hyphy (2.5.63+dfsg-1build1) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 10:00:59 +0100

hyphy (2.5.63+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.63+dfsg
  * set-zlib-after-setting-default-libs.patch: unfuzz.
  * use_debian_sqlite.patch: unfuzz.
  * d/rules: locate all HYPHYMPI to erase DT_RUNPATH.

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Nov 2024 11:54:22 +0100
