## hyphy 2.5.68+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 #enable_language(Fortran)
 
 set(CMAKE_CONFIGURATION_TYPES Release)
+
 
 #-------------------------------------------------------------------------------
 # OPTIONS
@@ -170,11 +171,13 @@
 
 set(DEFAULT_WARNING_FLAGS " -w -Weffc++ -Wextra -Wall ")
 set(DEFAULT_DEBUG_WARNING_FLAGS "-Wall -Wno-int-to-pointer-cast -Wno-conversion-null -Wno-sign-compare")
-set(ADDITIONAL_FLAGS "")
+set(ADDITIONAL_FLAGS "-g")
 
 if (DEBUGFLAGS)
 	set(ADDITIONAL_FLAGS "-g")
 endif()
+
+#include_directories("/Library/Developer/CommandLineTools/SDKs/MacOSX15.2.sdk/usr/include/c++/v1")
 
 
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
@@ -350,5 +353,3 @@
     set(DEFAULT_LIBRARIES dl)
 endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
 
-#-------------------------------------------------------------------------------
-# LIBCurl support
