=== debian/changelog ===
hyphy (2.5.68+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.68+dfsg
  * d/patches/*: unfuzz all patches.

 -- Étienne Mollier <emollier@debian.org>  Sat, 15 Feb 2025 19:20:03 +0100
