=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libpython3-all-dev,
                python3-all-dev:any,
                chrpath
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: https://hyphy.org/
