=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	;       mv -v "$${file}.new" "$${file}" \
 	; done
 	dh_install -a
-	chrpath --delete obj-*/HYPHYMPI
+	find -type f -name HYPHYMPI -exec chrpath --delete '{}' ';'
 ifeq (amd64,$(DEB_HOST_ARCH))
 	mkdir -p debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin
 	mkdir -p debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin
