## hyphy 2.5.69+dfsg

=== debian/changelog ===
hyphy (2.5.69+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Drop myself from uploaders
  * Drop Redundant "Rules-Requires-Root: no"
  * Fixup old-fsf-address-in-copyright-file
  * Move d/watch to version 5

 -- Nilesh Patra <nilesh@debian.org>  Sun, 02 Nov 2025 20:27:03 +0530

hyphy (2.5.69+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.69+dfsg (no changes).
  * rm_arch_specific_flags.patch: update to include NEON variants.
    This is needed to fix illegal instruction errors seen in autopkgtest.
  * d/rules: leave a note to build NEON SIMDe variants.
  * d/control: declare compliance to standards version 4.7.2.

 -- Étienne Mollier <emollier@debian.org>  Wed, 05 Mar 2025 12:43:12 +0100
