=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,8 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+# FIXME: build NEON SIMDe variants for Aarch64.
 
 override_dh_auto_clean:
 ifeq (amd64,$(DEB_HOST_ARCH))
