=== debian/watch ===
Version: 5

Template: Github
Owner: veg
Project: hyphy
Repacksuffix: +dfsg
Dversion-Mangle: s/\+dfsg//g
